//------------------------------------------------------------------------------
// Общие функции
//------------------------------------------------------------------------------
function FullReset()
{
	window.location.reload();
}

// Устанавливает печеньку :)
function SetCookie(name, value, expires, path, domain, secure)
{
	var curCookie = name + "=" + escape(value) +
		((expires) ? "; expires=" + expires.toGMTString() : "; expires=0, 01-01-2050 00:00:00 GMT") +
		((path) ? "; path=" + path : "") +
		((domain) ? "; domain=" + domain : "") +
		((secure) ? "; secure" : "");
	if ((name + "=" + escape(value)).length <= 4000) document.cookie = curCookie;
}

// Читает печеньку :)
function GetCookie(name, defval) 
{
	var prefix = name + "=";
	var cookieStartIndex = document.cookie.indexOf(prefix);
	if (cookieStartIndex == -1) return defval;
	var cookieEndIndex = document.cookie.indexOf(";", cookieStartIndex + prefix.length);
	if (cookieEndIndex == -1) cookieEndIndex = document.cookie.length;
	return unescape(document.cookie.substring(cookieStartIndex + prefix.length, cookieEndIndex));
}

//------------------------------------------------------------------------------
// Автопрокрутка журнала сообщений
//------------------------------------------------------------------------------
MessageLog =
{
	LockScroll: true,
	AutoScroll: function()
	{
		if(!this.LockScroll) return;
		var o = $("#main")[0];
		o.scrollTop = o.scrollHeight-o.clientHeight;
	},
	CheckScroll: function()
	{
		var o = $("#main")[0];
		this.LockScroll = (o.scrollTop >= o.scrollHeight - o.clientHeight*1.20);
	},
	Add: function(text)
	{
		$("#main").append("<div>"+text+"</div>");
		this.AutoScroll();
	}
};

$(document).ready(function() 
{
	$("#main").scroll(function()
	{
		MessageLog.CheckScroll();
	});
	$(window).resize(function()
	{
		MessageLog.AutoScroll();
		MessageLog.CheckScroll();
	});
});


//------------------------------------------------------------------------------
// Редактор сообщения
//------------------------------------------------------------------------------
MessageEdit =
{
	Color: "000000",
	AddressTo: "",
	Sended: false,
	SetColor: function(color)
	{
		if(color==null) this.Color = GetCookie("ChatColor", this.Color); else this.Color = color;
		SetCookie("ChatColor", this.Color);
		$("#message").css("color", '#'+this.Color);
	},
	To: function(login, priv)
	{
		var type = (priv==true)?"private":"to";
		var Message = $("#message").val();
		if(Message.indexOf(this.AddressTo)!=0) this.AddressTo = "";
		Message = Message.substring(this.AddressTo.length);
		if(this.Sended)
		{
			this.AddressTo = "";
			this.Sended = false;
		}
		if(this.AddressTo.indexOf(type)!=0) this.AddressTo = "";
		var NewAddr = type+" ["+login+"] ";
		if(this.AddressTo.indexOf(NewAddr)==-1) 
		{
			// Добавляем новое обращение
			this.AddressTo += NewAddr;
		}
		else
		{
			// Удаляем существующее обращение
			var i = this.AddressTo.indexOf(NewAddr)
			this.AddressTo = this.AddressTo.substring(0, i) + this.AddressTo.substring(i+NewAddr.length);
		}
		$("#message").val(this.AddressTo + Message).focus();
	},
	Smilie: function(s)
	{
		var Message = $("#message").val();
		$("#message").val(Message+" "+s+" ").focus();
	},
	SendClick: function()
	{
		var Message = $("#message").val();
		if(Message.indexOf(this.AddressTo)!=0) this.AddressTo = "";
		if(Message == "")
		{
			RefreshChat();
		}
		else if(Message == this.AddressTo) 
		{
			$("#message").val("");
			this.AddressTo = "";
		}
		else
		{
			this.Sended = true;
			SendMessage(Message, this.Color); 
			$("#message").val(this.AddressTo);
		}
		$("#message").focus();
	}
};

$(document).ready(function() 
{
	MessageEdit.SetColor(null); // Загружаем из куков
	$("#message").keypress(function(e)
	{
		if (e.which == 13) MessageEdit.SendClick();
	});
	$("#btn-send").click(function(e)
	{
		MessageEdit.SendClick();
		return false;
	});	
});

//------------------------------------------------------------------------------
// Звуки
//------------------------------------------------------------------------------
Sound =
{
	Enabled: 0,
	Enable: function(onoff)
	{
		if(onoff==null) 
			this.Enabled = GetCookie("ChatSound", this.Enabled); 
		else 
			this.Enabled = onoff?1:0;
		this.Enabled = parseInt(this.Enabled);
		SetCookie("ChatSound", this.Enabled);
		if(this.Enabled)
		{
			$("#btn-sound").css("background-position", "right bottom");
			if(!$("sound-swf").length)
			{
				$(document.body).append('<div id="sound-swf" style="position: absolute; left: -500px; top: -500px; width: 1px; height: 1px;"></div>');
				// Не jQuery потому что иначе IE не создает объект флэша
				document.getElementById("sound-swf").innerHTML = '<object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" codebase="http://fpdownload.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=8,0,0,0" width="0" height="0" id="playsound"><param name="allowScriptAccess" value="sameDomain" /><param name="movie" value="media/playsound.swf" /><embed src="media/playsound.swf" width="0" height="0" name="playsound" allowScriptAccess="sameDomain" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/go/getflashplayer" /></object>';
			}
		}
		else
			$("#btn-sound").css("background-position", "left top");
	},
	Play: function(src)
	{
		var FlashMovie = function(movieName) 
		{
			if (navigator.appName.indexOf("Microsoft") != -1) return window[movieName];
			else return document[movieName];
		}
		if(this.Enabled && FlashMovie("playsound").PlaySound) FlashMovie("playsound").PlaySound(src);
	}
};

$(document).ready(function() 
{
	Sound.Enable(null); // Загружаем из куков
	$("#btn-sound").click(function(e)
	{
		Sound.Enable(!Sound.Enabled);
		return false;
	});
});

//------------------------------------------------------------------------------
// Вывод журнала сообщений
//------------------------------------------------------------------------------
function addslashes(str) 
{
	return str.replace(/\\/g,'\\\\').replace(/\'/g,'\\\'').replace(/\"/g,'\\"').replace(/\0/g,'\\0');
}

function stripslashes(str) 
{
	return str.replace(/\\'/g,'\'').replace(/\\"/g,'"').replace(/\\0/g,'\0').replace(/\\\\/g,'\\');
}

function log(s)
{
	LogEvent(s);
}

function LogEvent(text)
{
	$("#main").append("<div>"+text+"</div>")
	MessageLog.AutoScroll();
}

function LogMessage(id,time,nick,msg,color)
{
	var html = "";
	if(time) html += "<span class='date'>"+time+"</span>&nbsp;";
	if(nick) html += "[<a href='#' onclick=\"javascript:MessageEdit.To('"+addslashes(nick)+"'); return false;\">"+nick+"</a>]&nbsp;";
	if(color) html += "<span style='color:#"+color+"'>"+msg+"</span>"; else html += msg;
	LogEvent(html);
}

function LogUserJoin(id,time,nick)
{
	LogEvent("<span class='date'>"+time+"</span> {L_USER_JOINED} [<a href='#' onclick=\"javascript:MessageEdit.To('"+addslashes(nick)+"'); return false;\">"+nick+"</a>]");
}

function LogUserLeft(id,time,nick)
{
	LogEvent("<span class='date'>"+time+"</span> {L_USER_LEFT} [<a href='#' onclick=\"javascript:MessageEdit.To('"+addslashes(nick)+"'); return false;\">"+nick+"</a>]");
}

function SetUsers(users)
{
	document.getElementById("users").innerHTML="<h1>{L_NOW_IN_CHAT} ("+users.length+")</h1>";
	for(var i = 0; i < users.length; i++)
	{
		var obj = document.createElement('div');
		obj.innerHTML="";
		obj.innerHTML+="&nbsp;<a href='#' onclick=\"javascript:MessageEdit.To('"+addslashes(users[i].name)+"', true); return false;\"><img src='media/private.png' height='10px' width='10px' border='0' title='{L_PRIVATE}' /></a>&nbsp;";
		obj.innerHTML+="<a href='#' onclick=\"javascript:MessageEdit.To('"+addslashes(users[i].name)+"'); return false;\">"+users[i].name+"</a>";
		document.getElementById("users").appendChild(obj);
	}
}


//------------------------------------------------------------------------------
// Обновление
//------------------------------------------------------------------------------
ChatKernel = 
{
	
};

function ShowIcon(name)
{
	$("#icon-error").hide();
	$("#icon-sending").hide();
	$("#icon-loading").hide();
	$("#icon-"+name).show();
}

var InProgress 	= false;
var LastUpdate	= 0;

function StartUpdate()
{
	if(InProgress) return false;
	InProgress = true;
	return true;
}

function EndUpdate()
{
	InProgress = false;
}

function RefreshChat()
{
	if(!StartUpdate()) return;
	ShowIcon("loading");
	$.ajax(
	{
		type: 		"POST",
		url: 		"index.php?build={BUILD_TIME}&rnd="+escape(Math.random()),
		data: 		{"action": "sync", "lastid": LastUpdate},
		timeout:	15000,
		success: function(js)
		{
			ShowIcon("none");
			eval(js);
			EndUpdate();
		},
		error: function()
		{
			ShowIcon("error");
			EndUpdate();
		}
	});
}

function SendMessage(text, color)
{
	ShowIcon("sending");
	if(!color) color = "000000";
	$.ajax(
	{
		type: 		"POST",
		url: 		"index.php?build={BUILD_TIME}&rnd="+escape(Math.random()),
		data: 		{"action": "say", "text": text, "color": color},
		timeout:	10000,
		success: function(js)
		{
			ShowIcon("none");
			eval(js);
			RefreshChat();
		},
		error: function()
		{
			ShowIcon("error");
		}
	});
}

function SetLastId(lastid)
{
	if(lastid) if(LastUpdate != lastid)
	{
		LastUpdate = lastid;
		Sound.Play("media/event.mp3");
	}
}

var ChatDelay = 15;			// Скорость обновления
var ChatTimer = -1;			// Таймер обновления

function SetDelay(delay)
{
	if(delay==null) 
	{
		ChatDelay = GetCookie("ChatDelay", ChatDelay); 
		document.getElementById("refresh").value=ChatDelay;
	} 
	else ChatDelay = delay;
	SetCookie("ChatDelay", ChatDelay);
	if (ChatTimer>=0) clearInterval(ChatTimer);
	ChatTimer = setInterval('RefreshChat()', ChatDelay*1000);
}

//------------------------------------------------------------------------------
// Точка входа
//------------------------------------------------------------------------------
$(document).ready(function() 
{
	SetDelay(null);
	RefreshChat();
});

//------------------------------------------------------------------------------
// Вывод таблицы с цветами (C) 23.03.2006 VEG
//------------------------------------------------------------------------------
function GradColors(colmax) 
{
	var colhex = ["00", "33", "66", "99", "cc", "ff"];
	var coldat = [colmax, 0, 0];
	var colcur = 2;
	var result = [];
	do	
	{
		if((coldat[colcur]!=colmax)&&(coldat[(colcur+1)%3]==colmax)) coldat[colcur]++; else 
		if ((coldat[colcur]==colmax)&&(coldat[(colcur+1)%3]!=0)) coldat[(colcur+1)%3]--; else 
		{
			colcur--; 
			if(colcur>=0) coldat[colcur]++;
		};
		if(colcur>=0) result[result.length]=colhex[coldat[0]]+colhex[coldat[1]]+colhex[coldat[2]];
	} while (colcur!=-1);
	return result;
}

function WriteColorTable(rows, width, height)
{
	document.write("<table border='0' cellspacing='0' cellpadding='0' width='"+width+"px' style='cursor: pointer; border-spacing: 0;'>");
	for(var i=rows; i>=1; i--)
	{
		document.write("<tr><td><table border='0' cellspacing='0' cellpadding='0' width='100%' height='"+height+"px'><tr>");
		var grad = GradColors(i);
		var wcur = 0;
		for(var j=0; j<grad.length; j++)
			document.write("<td style='font-size: 1px; background-color: #"+grad[j]+"' onclick='javascript:MessageEdit.SetColor(\""+grad[j]+"\");'><div style='height: 1px; width: 1px;'></div></td>");
		document.write("</tr></table></td></tr>");
	}
	document.write("</table>");
}